# Changelog

## [0.3] 2022-02-02

### Fixed
- Apply AF thresholds on unbiased AF values recalculated from DP4 and DP fields
  instead of on AF values provided by the variant caller to ensure proper
  variant gating (into consensus and ambiguous variants) for lofreq-called
  data.

  https://github.com/CSB5/lofreq/issues/80 means that lofreq-calculated AF
  values are lower bounds of true AFs when bases are excluded from calling
  based on base quality. The extent of AF underestimation depends on the
  fraction of bases with sub-threshold (30 for this workflow) base qualities.

  By recalculating AFs as (DP4[2] + DP4[3]) / DP we avoid this issue for
  variant calls generated by lofreq. For variants called with Galaxy's medaka
  consensus/variant wrappers, original AFs are computed with the exact same
  formula so the recalculation by the workflow does not affect variant gating
  in that case.

### Changed
- Increase the default for consensus variant allele frequency threshold to 0.75.
  Correct calculation of unbiased AF values increases the typical AF of
  consensus variants more than enough to justify the change.
- The following tools are updated to their latest wrapper versions or revisions:

  - bcftools_consensus
  - collapse_collections
  - the gops subtract and merge tools
  - snpsift

  None of these updates are expected to impact the generated consensus
  sequences.

## [0.2.2] 2021-12-13

### Added
- Added GitHub Actions workflow. No functional changes.

## [0.2.1] 2021-07-23

### Added

Added RO-Crate metadata file. No functional changes.

## [0.2] - 2021-04-30

### Changed
- Lower the default for consensus variant allele frequency threshold to 0.7
  (from 0.8).
  This was empirically determined to capture a relevant number of variants at
  sites that are problematic to call.
- Increase the default variant allele frequency threshold for ambiguous sites
  to 0.25 (from 0.2) to obtain somewhat cleaner consensus sequences.
- Use *SnpSift extract*, instead of *VCFtoTab-delimited* followed by *Cut*, to
  generate required tabular views of variants in one step.
- Eliminate the use of *bedtools MaskFastaBed*, which was redundant with
  specifying masking regions directly at the *bcftools consensus* step.
- Reduce the number of processing steps further by changing result dataset
  types through post-job actions appropriately to avoid implicit conversions,
  and by avoiding a redundant *SnpSift filter* step.

### Fixed
- Deletions are now reliably incorporated into the consensus sequence.
  Before they were, in most cases, N-masked because of low coverage in the
  deleted region.
- Generally, each consensus sequence is now guaranteed to capture all consensus
  variants of its samples as stated in the README, independent of it residing
  in low-coverage regions or not.

## [0.1]

- Initial version of COVID-19: consensus construction
